GraphWriter< GR > Class Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Public Member Functions | Related Functions
GraphWriter< GR > Class Template Reference
LEMON Graph Format

## Detailed Description

### template<typename GR>
class lemon::GraphWriter< GR >

This utility writes an LGF file.

It can be used almost the same way as `DigraphWriter`. The only difference is that this class can handle edges and edge maps as well as arcs and arc maps.

The arc maps are written into the file as two columns, the caption of the columns are the name of the map prefixed with `'+'` and `'-'`. The arcs are written into the `@attributes` section as a `'+'` or a `'-'` prefix (depends on the direction of the arc) and the label of corresponding edge.

`#include <lemon/lgf_writer.h>`

## Public Member Functions
| GraphWriter (const GR &graph, std::ostream &os=std::cout)
| Constructor. More...
| GraphWriter (const GR &graph, const std::string &fn)
| Constructor. More...
| GraphWriter (const GR &graph, const char *fn)
| Constructor. More...
| ~GraphWriter ()
| Destructor.
Writing Rules
template<typename Map >
GraphWriter & | nodeMap (const std::string &caption, const Map &map)
| Node map writing rule. More...
template<typename Map , typename Converter >
GraphWriter & | nodeMap (const std::string &caption, const Map &map, const Converter &converter=Converter())
| Node map writing rule. More...
template<typename Map >
GraphWriter & | edgeMap (const std::string &caption, const Map &map)
| Edge map writing rule. More...
template<typename Map , typename Converter >
GraphWriter & | edgeMap (const std::string &caption, const Map &map, const Converter &converter=Converter())
| Edge map writing rule. More...
template<typename Map >
GraphWriter & | arcMap (const std::string &caption, const Map &map)
| Arc map writing rule. More...
template<typename Map , typename Converter >
GraphWriter & | arcMap (const std::string &caption, const Map &map, const Converter &converter=Converter())
| Arc map writing rule. More...
template<typename Value >
GraphWriter & | attribute (const std::string &caption, const Value &value)
| Attribute writing rule. More...
template<typename Value , typename Converter >
GraphWriter & | attribute (const std::string &caption, const Value &value, const Converter &converter=Converter())
| Attribute writing rule. More...
GraphWriter & | node (const std::string &caption, const Node &node)
| Node writing rule. More...
GraphWriter & | edge (const std::string &caption, const Edge &edge)
| Edge writing rule. More...
GraphWriter & | arc (const std::string &caption, const Arc &arc)
| Arc writing rule. More...
Section Captions
GraphWriter & | nodes (const std::string &caption)
| Add an additional caption to the `@nodes` section. More...
GraphWriter & | edges (const std::string &caption)
| Add an additional caption to the `@edges` section. More...
GraphWriter & | attributes (const std::string &caption)
| Add an additional caption to the `@attributes` section. More...
Skipping Section
GraphWriter & | skipNodes ()
| Skip writing the node set. More...
GraphWriter & | skipEdges ()
| Skip writing edge set. More...
Execution of the Writer
void | run ()
| Start the batch processing. More...
std::ostream & | ostream ()
| Give back the stream of the writer. More...

## Related Functions
(Note that these are not member functions.)
template<typename TGR >
GraphWriter< TGR > | graphWriter (const TGR &graph, std::ostream &os)
| Return a GraphWriter class. More...
template<typename TGR >
GraphWriter< TGR > | graphWriter (const TGR &graph, const std::string &fn)
| Return a GraphWriter class. More...
template<typename TGR >
GraphWriter< TGR > | graphWriter (const TGR &graph, const char *fn)
| Return a GraphWriter class. More...

## Constructor & Destructor Documentation

GraphWriter | ( | const GR & | graph,
|  | std::ostream & | os = `std::cout`
| ) |  |
| inline

Construct an undirected graph writer, which writes to the given output stream.

GraphWriter | ( | const GR & | graph,
|  | const std::string & | fn
| ) |  |
| inline

Construct a undirected graph writer, which writes to the given output file.

GraphWriter | ( | const GR & | graph,
|  | const char * | fn
| ) |  |
| inline

Construct a undirected graph writer, which writes to the given output file.

## Member Function Documentation

GraphWriter& nodeMap | ( | const std::string & | caption,
|  | const Map & | map
| ) |  |
| inline

Add a node map writing rule to the writer.

GraphWriter& nodeMap | ( | const std::string & | caption,
|  | const Map & | map,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add a node map writing rule with specialized converter to the writer.

GraphWriter& edgeMap | ( | const std::string & | caption,
|  | const Map & | map
| ) |  |
| inline

Add an edge map writing rule to the writer.

GraphWriter& edgeMap | ( | const std::string & | caption,
|  | const Map & | map,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add an edge map writing rule with specialized converter to the writer.

GraphWriter& arcMap | ( | const std::string & | caption,
|  | const Map & | map
| ) |  |
| inline

Add an arc map writing rule to the writer.

GraphWriter& arcMap | ( | const std::string & | caption,
|  | const Map & | map,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add an arc map writing rule with specialized converter to the writer.

GraphWriter& attribute | ( | const std::string & | caption,
|  | const Value & | value
| ) |  |
| inline

Add an attribute writing rule to the writer.

GraphWriter& attribute | ( | const std::string & | caption,
|  | const Value & | value,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add an attribute writing rule with specialized converter to the writer.

GraphWriter& node | ( | const std::string & | caption,
|  | const Node & | node
| ) |  |
| inline

Add a node writing rule to the writer.

GraphWriter& edge | ( | const std::string & | caption,
|  | const Edge & | edge
| ) |  |
| inline

Add an edge writing rule to writer.

GraphWriter& arc | ( | const std::string & | caption,
|  | const Arc & | arc
| ) |  |
| inline

Add an arc writing rule to writer.

GraphWriter& nodes | ( | const std::string & | caption | ) |
| inline

Add an additional caption to the `@nodes` section.

GraphWriter& edges | ( | const std::string & | caption | ) |
| inline

Add an additional caption to the `@edges` section.

GraphWriter& attributes | ( | const std::string & | caption | ) |
| inline

Add an additional caption to the `@attributes` section.

GraphWriter& skipNodes | ( |  | ) |
| inline

The `@nodes` section will not be written to the stream.

GraphWriter& skipEdges | ( |  | ) |
| inline

The `@edges` section will not be written to the stream.

void run | ( |  | ) |
| inline

This function starts the batch processing.

std::ostream& ostream | ( |  | ) |
| inline

Give back the stream of the writer

## Friends And Related Function Documentation

GraphWriter< TGR > graphWriter | ( | const TGR & | graph,
|  | const std::string & | fn
| ) |  |
| related

This function just returns a GraphWriter class.

See Also
  graphWriter(const TGR& graph, std::ostream& os)

GraphWriter< TGR > graphWriter | ( | const TGR & | graph,
|  | const char * | fn
| ) |  |
| related

This function just returns a GraphWriter class.

See Also
  graphWriter(const TGR& graph, std::ostream& os)